(*
   In  P R 1 . P A S  sind die Routinen zum direkten Ansprechen des
   TNC im Hostmode zusammengefasst. Auerdem enthalten sind die
   LogOn- und LogOff-Prozeduren.

   DL1BHO, im Mai 1988
*)


(*
   Eine HOSTMODE-Zeile an den TNC senden
   Format:   SendTNC(KanalNummer,Art(0=Text,1=Kommando),String)
*)

procedure SendTNC (* (Kanal,Art : integer ; Zeile : str255) *);
var   Laenge  : char;
      Channel : char;
Begin
  if Kanal = 0 then
  Begin
    (* RS232 von poll_Moni einschalten *)
    switch_V24(poll_Moni);
  End
  else
  Begin
    (* RS232 von Kanal einschalten *)
    switch_V24(K[Kanal]^.RS232);
  End;
  Laenge := chr(length(Zeile)-1);
  Channel := K[Kanal]^.TNCKanal;
  SendKanal := Kanal;
  writeaux(Channel + chr(Art) + Laenge);
  writeaux(Zeile);
End;


(* Disconnect-Prozedur *)

procedure L_Off (* (Kanal : integer) *);

var AMerk    : byte;
    i        : integer;
    chx      : CHAR;
label log;


Begin
  AMerk := TextAttr;
  with K[Kanal]^ do
  Begin
    delete(Response,1,4);
    TNC_K := false;
    i := pos(' - ',Response);
    if i <> 0 then
    Begin
      (* TNC V2.1c hat Uhrzeit gesendet *)
      TNC_K := true;
      TNC_Date := copy(Response,i+3,8);
      if TNC_Date[3] = '/' then (* amerikanisches Format *)
        TNC_Date := copy(TNC_Date,4,2) + '.' + copy(TNC_Date,1,2) +
                    '.' + copy(TNC_Date,7,2);
      TNC_Date := WochenTag(TNC_Date) + ' ' + TNC_Date;
      TNC_Time := copy(Response,i+12,8);
      delete(Response,i,20);
    End;
    qsoEnde := copy(Time,1,5);
    if (NOT Sek30) AND TNC_K then qsoEnde := copy(TNC_Time,1,5);
    if X2 > 1 then _aus(Kanal,^M);
    _aus(Kanal,inf + copy(Response,1,length(Response)-1));
    if (Sek30 OR TNC_K) AND connected
      then _aus(Kanal,' (' + qsoDatum + ' ' + qsoEnde + ')');
    _aus(Kanal,^M^M);
    if FileSend then
    Begin
      close(TXFile);
      FileSend := false;
      StatusOut(Kanal,58,dunkel,'      ');
    End;
    if connected then
    Begin
      StatusOut(Kanal,4,dunkel,copy(space,1,9));
      connected := false;
      Status2;
      if Sek30 OR TNC_K then
      Begin
        if Klingel AND Sek30 then D_Bell;

      log:

        (* Logeintrag machen *)
        (*$I-*) append(LogFile); (*$I+*)
        i := IOResult;
        if i <> 0 then
        Begin
          if Klingel then triller;
          TextAttr := norm;
          CASE i OF
           2 : BEGIN
                 Fenster(20,8,37,9,'LOGFILE nicht gefunden!');
                 GotoXY(22,11); WRITE('Disk mit File ''PACK.LOG'' einlegen');
                 GotoXY(25,12); WRITE('<R>etry');
                 GotoXY(25,13); WRITE('<E>rstelle neues PACK.LOG');
                 GotoXY(30,15); WRITE('Drcke <R> / <E>');
                  repeat
                     chx := upcase(ReadKey);
                  until (chx = 'R') or (chx = 'E');
                  if chx = 'E' then rewrite(logfile);
                 Neu_Bild;
                 goto log;
               END;
           152:BEGIN
                 Fenster(20,8,37,8,'LAUFWERK nicht bereit !');
                 gotoxy(22,11); write('Disk mit File ''PACK.LOG'' einlegen');
                 gotoxy(22,12); write('und Laufwerk schlieen !');
                 gotoxy(28,14); write(weiter);
                 wd:=Taste;
                 Neu_Bild;
                 GOTO Log;
               END;
           ELSE
               BEGIN
                 Fenster(20,8,38,7,'DOS-ERROR Nr. '+Int_Str(i)+' beim Logeintrag !');
                 gotoxy(22,11); write('Logeintrag wird nicht vorgenommen.');
                 gotoxy(24,13); write(weiter);
                 wd:=Taste;
                 Neu_Bild;
               END;
          END; (* CASE ... *)
        End
        else
        Begin
          writeln(LogFile,qsoDatum,'  ',qsoBeginn,' - ',qsoEnde,
                      ' ',LogMerker,' ',Channel_ID(Kanal),conText);
          close(LogFile);
        END;
      End;
      IF Sek30 AND Save THEN BEGIN
        (* File nach Disconnect schliessen und wieder oeffnen *)
        Close(RXFile);
        IF (RX_bin = 0) THEN OpenSaveFile(Kanal)
                        else begin
                           StatusOut(show,15,dunkel,copy(space,1,12));
                           save:=false;
                        end;
      END;
    End; (* if connected ... *)
    Outside := true;
  End; (* WITH K[Kanal] ... *)
  TextAttr := AMerk;
End;


(* Connect-Prozedur *)

procedure L_ON (* (Kanal : integer ; Connect_out : boolean) *);
var B_Dummy   : INTEGER;
    i         : integer;
    ZStr      : STRING[80];  (* Hilfsstring *)
Begin
  with K[Kanal]^ do
  Begin
    if ScreenSTBY then
    Begin
      ScreenSTBY := false;
      ScreenTimer := ScreenInit;
      Neu_Bild;
    End;

    TNC_K := false;
    i := pos(' - ',Response);
    if i <> 0 then
    Begin                            (* TNC V2.1c hat Uhrzeit gesendet *)
      TNC_K := true;
      TNC_Date := copy(Response,i+3,8);
      if TNC_Date[3] = '/' then               (* amerikanisches Format *)
        TNC_Date := copy(TNC_Date,4,2) + '.' + copy(TNC_Date,1,2) +
                    '.' + copy(TNC_Date,7,2);
      TNC_Date := WochenTag(TNC_Date) + ' ' + TNC_Date;
      TNC_Time := copy(Response,i+12,8);
      delete(Response,i,20);               (* Datum/Uhrzeit abschneiden *)
    End;

    NRPwOK := false;   NochNichtGelesen := FALSE;

    Call := CutStr(copy(Response,18,length(Response)-18));
    i:=pos(#13,call); if i <> 0 then call:=copy(call,1,i-1);
    StatusOut(Kanal,4,dunkel,'         ');
    StatusOut(Kanal,4,hell,Call);
    connected:=true;
    nr_auswert:=0; anz_auswert:=0;          (* nach jedem connect rcksetzen *)
    qsoDatum := Date;  qsoBeginn := copy(Time,1,5);
    if (NOT Sek30) AND TNC_K then
         Begin qsoDatum := TNC_Date;  qsoBeginn := TNC_Time; End;
    ConText := copy(Response,18,length(Response)-18);
    first_Frame := true;
    delete(Response,1,4);
    if Connect_out then                                (* connect von auen *)
    Begin
      _aus(Kanal,inf + copy(Response,1,length(Response)-1));
      if Sek30 OR TNC_K then _aus(Kanal,' (' + qsoDatum + ' ' + qsoBeginn + ')');
      _aus(Kanal,^M);
    End;
    Status2;
    if Auto_cmd then
    Begin
      Outside := false;
      if cmd_Stufe > end_cmd(cmd_Nummer) then Auto_cmd := false;
      if Auto_cmd then
      Begin
        ZStr := Auto_Command(Kanal,cmd_Nummer,cmd_Stufe) + ^M;
        _aus(Kanal,ZStr);
        S_Text(Kanal,ZStr);
        inc(cmd_Stufe);
      End;
    End;
    if Sek30 and Klingel then C_Bell;  (* bei jedem Connect 'bellen' *)
  End;  (* with K[Kanal] do... *)
End;


function RufZeichen (* (Zeiger : integer ; const_Laenge : integer) : str9 *);
var  i     : integer;
     b_str : str9;
Begin
  with K[0]^ do
  Begin
    b_str := '';
    for i := Zeiger to (Zeiger+5) do
    Begin
      if Response[i] <> #64 then b_str := b_str + chr(ord(Response[i]) div 2);
    End;
    IF (Ord(Response[Zeiger+6]) DIV 2) <> 48 THEN BEGIN
      i := (Ord(Response[Zeiger+6]) DIV 2) - 48;
      IF (i > 15) OR (i < 0)
        THEN
          BEGIN
            (* passiert bei falsch programmierten TheNet-Eproms !! *)
            b_str := b_str + '-?';
          END
        ELSE
          BEGIN
            IF (i <> 0) THEN b_str := b_str + '-' + int_str(i);
          END;
    END;
    IF const_Laenge = 1 then b_str := b_str + ConstStr(' ',9-length(b_str));
  End;
  RufZeichen := b_str;
End;


function Flags;
const Flag_str = 'CNMR';  (* Choke,NAK,More-follows,Reserved *)
var   b_str    : str8;
      flgs,i   : integer;
Begin
  with K[0]^ do
  Begin
    b_str := '';
    flgs := ord(Response[20]) shr 4;
    for i := 1 to 4 do
    Begin
      if flgs mod 2 <> 0 then b_str := copy(Flag_str,i,1) + b_str
                         else b_str := '.' + b_str;
      flgs := flgs shr 1;
    End;
  End;
  Flags := ' '+ b_str + ' ';
End;


function Broadcast (* (Stelle : integer) : str40 *);
 var b_str    : str40;
     b1_str   : string[5];
     i        : integer;
Begin
  with K[0]^ do
  Begin
    b_str := '';
    for i := (Stelle+7) to (Stelle+12) do
    Begin
      if Response[i] <> ' ' then b_str := b_str + Response[i];
    End;
    if Response[Stelle+7] <> ' ' then b_str := b_str + ':';
    b_str := b_str + RufZeichen(Stelle,1);
    b_str := b_str + constStr(' ',17-Length(b_str)) + 'via ';
    b_str := b_str + RufZeichen(Stelle+13,1) + ' ';
    str(ord(Response[Stelle+20]),b1_str);
    b_str := b_str + b1_str + ^M;
  End;
  Broadcast := b_str;
End;


procedure NETROM_aus;
Begin
  with K[0]^ do
  Begin
    M_aus('('+Rufzeichen(1,0)+' > '+RufZeichen(8,0));
    M_aus(' LT:'+int_str(ord(Response[15]))+ ' ');
  End;
End;



function NetRomPw;        (* (Kanal : integer ; Parms1 : FuenfString) : str8 *)
var Zeile          : string[128];
    Call_gefunden  : boolean;
    i,i1,r          : integer;
    B_Str          : str8;
Begin
  B_Str := '';
  if NR_remote then
  Begin
    reset(NRPWFile);
    Call_gefunden := false;
    repeat
      readln(NRPWFile,Zeile);
      if Zeile = K[Kanal]^.Call then Call_gefunden := true;
    until Call_gefunden or eof(NRPWFile);
    B_Str := '';
    if Call_gefunden then
    Begin
      readln(NRPWFile,Zeile);
      for i := 1 to 5 do
      Begin
        val(Parms1[i],i1,r);
        if r <> 0 then i1 := 1;
        B_Str := B_Str + Zeile[i1];
      End;
      K[Kanal]^.NRPwOK := true;
    End;
    close(NRPWFile);
  End;
  NetRomPW := B_Str;
End;


procedure PARMS_Auswert (* (Kanal : integer ; Zeile : str255) *);
var  i             : integer;
     y             : byte;
     Parms         : array[1..37] of string[5];
     Parms1        : FuenfString absolute Parms;
     AMerk,Parms_Anzahl  : byte;
     B_Str         : str8;

 function Parm_str(i : byte; Name : str20) : str20;
 var hstr : str20;
 Begin
   hstr := int_str(i) + ': ' + Name + ' ' + Parms[i];
   if i < 10 then hstr := '0' + hstr;
   if (i mod 4)=0 then parm_str := hstr+copy(space,1,19-length(hstr))+^M
                  else parm_str := hstr+copy(space,1,20-length(hstr));
 End;

Begin
  AMerk := TextAttr;
  for i := 1 to length(Zeile) do
  Begin
    if Zeile[i] = #13 then Zeile[i] := ' ';
  End;
  fillchar(Parms,sizeof(Parms),#0);
  y := 1;
  for i := 1 to 37 do
  Begin
    while (Zeile[y] <> ' ') and (y <= length(Zeile)) do
    Begin
      Parms[i] := Parms[i] + Zeile[y];
      inc(y);
    End;
    inc(y);   (* Space ueberspringen *)
  End;

  Parms_Anzahl := 0;
  repeat
    inc(Parms_Anzahl);
  until (Parms_Anzahl = 37) or (Parms[Parms_Anzahl] = '');
  if Parms_Anzahl < 37 then Parms_Anzahl := pred(PArms_Anzahl);

  if (Parms_Anzahl = 24) or (Parms_Anzahl = 26) or
     (parms_anzahl = 30) or (parms_anzahl = 37) then
  Begin
    TextAttr := norm;

    _aus(Kanal,^M + 'NET/ROM PARMS-Auswertung:' + ^M^M);

    TextAttr := low;

    _aus(Kanal,Parm_str(1,'Max-Nodes')  + parm_str(2,'Min-Quality')+
               Parm_str(3,'HF-Quality') + parm_str(4,'V24-Quality')+
               Parm_str(5,'Obs-Init')   + Parm_str(6,'Min-BCast')+
               Parm_str(7,'Broadcast')  + parm_str(8,'Lifetime'));
    _aus(Kanal,Parm_str(9,'T-Timeout')  + Parm_str(10,'T-Retry')+
               Parm_str(11,'T-AckDelay')+ parm_str(12,'T-BsyDelay')+
               Parm_str(13,'T-Window')  + Parm_str(14,'NoAckBuf')+
               Parm_str(15,'Timeout'));

    if Parms_Anzahl = 24 then
    Begin
      (* NET/ROM 1.0 bis 1.2 *)
      _aus(Kanal,parm_str(16,'DWait')   + Parm_str(17,'FRACK') +
                 Parm_str(18,'MAXFRAME')+ Parm_str(19,'L2-Retry')+
                 parm_str(20,'T2-Timer')+ Parm_str(21,'T3-Timer')+
                 Parm_str(22,'L2-Digi') + Parm_str(23,'CallCheck')+
                 parm_str(24,'ID-Beacon'));
    End
    else
    Begin
      (* NET/ROM 1.3 *)
      _aus(Kanal,parm_str(16,'Persistance')+Parm_str(17,'SlotTime')+
                 Parm_str(18,'FRACK')     + Parm_str(19,'MAXFRAME')+
                 parm_str(20,'L2-Retry')  + Parm_str(21,'T2-Timer')+
                 Parm_str(22,'T3-Timer')  + Parm_str(23,'L2-Digi'));
      _aus(Kanal,parm_str(24,'CallCheck') + Parm_str(25,'ID-Beacon')+
                 parm_str(26,'CQ-UI-Frame'));
    End;
    if (parms_anzahl = 37) or (parms_anzahl =30) then (* THENET by DL2RBI *)
      _aus(kanal,parm_str(27,'Beacon')  + parm_str(28,'HidNode')+
                 parm_str(29,'AutoCon') + parm_str(30,'TXDelay'));
    if (parms_anzahl = 37) then
    begin
      _aus(kanal,parm_str(31,'Max-Links')+parm_str(32,'MinCrWait')+
                 parm_str(33,'MaxCrWait')+parm_str(34,'VorlCrLink'));
      _aus(kanal,parm_str(35,'unused')   + parm_str(36,'unused')+
                 parm_str(37,'unused'));
    end;
    _aus(Kanal,^M+^M);
  End
  else
   Begin              (* Fehler in der Umformung oder SYSOP-Kommando *)
    if Parms_Anzahl = 5 then begin
      B_Str := NetRomPw(Kanal,Parms1);
      with K[kanal]^ do begin
       if (B_Str <> '')  then begin              (* PassWort gefunden *)
         {$IFDEF SYSOP}
         if nr_auswert=0 then begin            (* nicht esc-s gemacht ! *)
         {$ENDIF}
           InputZeile := B_Str;  X1 := 1;
           _clreol(Kanal); V_aus(Kanal,InputZeile);
           Cursor(Kanal);
         {$IFDEF SYSOP}  end
         else begin                            (* hier esc-s gemacht *)
           _aus(kanal,'Nr. '+int_str(anz_auswert)+': ');
           if anz_auswert < 10 then _aus(kanal,' ');
           if anz_auswert < 100 then _aus(kanal,' ');
           if nr_auswert=anz_auswert then begin   (* richtiges wort *)
             zeile:=b_str;
             _aus(kanal,'Richtiges Wort  '+conststr('-',17)+'> : '+zeile+^M);
             end
           else begin                           (* wort von falschen zahlen *)
            for i1:=1 to 5 do
            begin
              parms1[i1]:=int_str(1+random(80));
              if length(parms1[i1])=1 then parms1[i1]:=' '+parms1[i1];
            end; { for i1:=1 to 5 }
            zeile:=netrompw(kanal,parms1);
            _aus(kanal,'Falsches Wort von: '+parms1[1]+' '+parms1[2]+' '+
                  parms1[3]+' '+parms1[4]+' '+parms1[5]+'  : '+zeile+^M);
           end; { if nr_auswert = anz_auswert }
           if anz_auswert>1 then S_text(kanal,zeile+#13+'SYS'+#13) (* nchstes wort *)
                            else
                            begin S_text(kanal,zeile+#13);(* ende der auto-*)
                               nr_auswert:=0; end;
           dec(anz_auswert); zeile:='';
         end; { if nr_auswert=0 }
       end
       else begin
          nr_auswert:=0; anz_auswert:=0;
       {$ENDIF}
       end; { if b_str <> '' }
      End; { with k[kanal]^ do }
    End;
  End;
  TextAttr := AMerk;
End;
