
(*
  Tastatur - Decoder  fuer  Turbo-Hostmode-Packet (THP ab Version 2.41)
  Version fr Turbo 4.0
  10/1988 DL1BHO

  nderung de DF1RW:

  05.02.89 - Um QRES und DEL von DJ0HC erweitert.
  06.02.89 - CALL, NET und D-Abfrage (DJ0HC) implementiert.

*)

Procedure AuswertTaste;   (* Tastatur-Decoder *)

label FileSendNochmal,Fileempfnochmal, nexttaste;

var i,i1,i2     : integer;
    ch          : char;
    AMerk       : byte;
    command     : integer;
    Err_Result  : integer;
    D_ON        : boolean;
    upcase_Zeile: str255;
    Filename    : Str60;
    NR_Par      : string[2];
    NR_Wert     : string[5];

 (* InputZeile nach einem CR bearbeiten *)

 procedure TX_out;
 var AMerk  : byte;
     ZStr   : STRING[10];   (* Pufferstring *)
 Begin
   AMerk := TextAttr;
   TextAttr := conTXAttrib;
   if show = 0 then poll_Moni := unproto;
   with K[show]^ do
   Begin
     Auto_cmd := FALSE;
     merkinput:=inputzeile;
     if show <> 0 then
     Begin
       eigText := true;
       if Drucker then write(lst,Printer1[7]);
       _aus(show,InputZeile);
       if Drucker then write(lst,Printer1[8]);
     End;
     if length(InputZeile) > PacLen then
     Begin
       repeat
         S_Text(show,copy(InputZeile,1,PacLen));
         delete(InputZeile,1,PacLen);
       until length(InputZeile) <= PacLen;
       S_Text(show,InputZeile);
     End
     else
     Begin
       S_Text(show,InputZeile);
     End;

     InputZeile := '';
   End;
   TextAttr := AMerk;
 End;  (* TX_out *)

 (* ein Zeichen darstellen und in den Sendepuffer uebernehmen *)

 procedure chr_darstell;
 Begin
   with K[show]^ do
   Begin
     InputZeile := InputZeile + ch_out;
     V_aus(show,^H+ch_out);
     if X1 = 80 then
     Begin                                           (* Zeilenende erreicht *)
       i1 := length(InputZeile) + 1;
       i2 := 0;
       repeat
         inc(i2);
         dec(i1);
       until (InputZeile[i1] = ' ') or (i2 = 79) or (i1 = 1);
       if (i2 = 79) or (i1 = 1) then
       Begin             (* Kein SPACE in dieser Zeile, also ein CR anfuegen *)
         InputZeile := InputZeile + #13;
         V_aus(show,^M);
       End
       else
       Begin
         InputZeile[i1] := #13;
         X1 := 80-i2;
         _clreol(show);
         V_aus(show,^M);
         V_aus(show,copy(InputZeile,i1+1,i2));
       End;
     End;
   End;
   Cursor(show);
 End;


 procedure FileMenue;
 Begin
   gotoxy(4,5);       writeln('(T)extfile');
   gotoxy(4,wherey);  writeln('(B)inrfile');
   gotoxy(4,wherey);  writeln('(A)uto-Binrfile');
   gotoxy(4,whereY);  writeln('<ESC> fr Abbruch');
   gotoxy(4,10);      write('Eingabe >>>  T,B,A,<ESC> ');
   gotoxy(15,10);
   Cursor_ein;
   repeat
     ch := upcase(ReadKey);
   until (ch='T') or (ch='B') or (ch='A') or (ch=#13) or (ch=#27);
   if ch = #13 then ch := 'T';
 End;

Begin                (* of AuswertTaste *)
  with K[show]^ do
  Begin
    AMerk := TextAttr;
    if Neu_Bild_if_keypressed then Neu_Bild;

    if ScreenSTBY then
    Begin
      Neu_Bild;
      ScreenSTBY := false;
      ch_out := #255;
    End;

    ScreenTimer := ScreenInit;  (* Bildschirm-Schoner wieder hochsetzen *)

    nexttaste:

    if cmd then
    Begin
      (* Kanal ist im Kommando-Modus *)
      case ch_out of
       ^M : Begin
              (* hier Ende der Kommandoeingabe *)
              Auto_cmd := FALSE;
              V_aus(show,^H' '^M);
              last_cmd := InputZeile;
              upcase_Zeile := upcasestr(InputZeile);

              if (copy(upcase_Zeile,1,2) = 'MH')    then command := 1 else
              if (copy(upcase_Zeile,1,3) = 'PAC')   then command := 2 else
              if (copy(upcase_Zeile,1,4) = 'CALL')  then command := 15 else
              { mu hier stehen bleiben, wegen 'C' .... }
              if upcase_Zeile[1]         = 'C'      then command := 3 else
              if (copy(upcase_Zeile,1,3) = 'DIR')   then command := 4 else
              if (copy(upcase_Zeile,1,2) = 'TY')    then command := 5 else
              if (copy(upcase_Zeile,1,3) = 'LOG')   then command := 6 else
              if (copy(upcase_Zeile,1,3) = 'PAR')   then command := 7 else
              if upcase_Zeile            = 'H'      then command := 8 else
              if (copy(upcase_Zeile,1,2) = 'HE')    then command := 9 else
              IF (copy(Upcase_Zeile,1,3) = 'SUB')   THEN command := 10 else
              IF (copy(Upcase_Zeile,1,4) = 'PRIV')  THEN command := 11 else
              IF upcase_Zeile[1]         = '?'      THEN command := 12 else
              IF upcase_Zeile[1]         = 'Q'      THEN command := 13 else
              if (copy(upcase_Zeile,1,3) = 'DEL')   then command := 14 else
              if (copy(upcase_Zeile,1,3) = 'DOS')   then command := 16 else
              if (copy(upcase_zeile,1,3) = 'I -')   then command := 17 else
              if (copy(upcase_zeile,1,2) = 'ID')    then command := 18 else
              {$IFDEF SYSOP}
              if upcase_zeile[1]         = 'S'      then command := 19 else
              {$ENDIF}
              if (copy(upcase_zeile,1,2) = '//')    then command := 20 else
               command := 99;

              CASE command OF

               1 : BEGIN                               (* MH *)
                     i := Pos(' ',upcase_Zeile);
                     IF (i <> 0)
                       THEN MH_darstellen(Copy(upcase_Zeile,i+1,9))
                       ELSE MH_darstellen('');
                   END;

               2 : Begin                              (* PAC *)
                     (* PacLen anzeigen/aendern *)
                     i := pos(' ',upcase_Zeile);
                     if i = 0 then
                     Begin
                       (* Kein neuer Wert angegeben *)
                       M_aus(Channel_ID(show)+'('+int_str(show)+') PACLEN ');
                       M_aus(int_str(PacLen) + ^M);
                     End
                     else
                     Begin
                       (* neuer Wert *)
                       val(copy(upcase_Zeile,i+1,length(upcase_Zeile)-i),i1,Err_Result);
                       if (Err_Result = 0) and
                          (i1 >= 10) and (i1 <= 255) then
                       Begin
                         PacLen := i1;
                       End
                       else
                       Begin
                         if Klingel then beep(220,20);
                         M_aus(Channel_ID(show) + '('+int_str(show)+
                               ') Fehler bei PACLEN-Eingabe!' + ^M);
                       End;
                     End;
                   End;

               3 : BEGIN                                 (* C *)
                     IF show=0 THEN poll_Moni:=unproto  else  Outside:=false;
                     S_Com(show,InputZeile);
                   END;

               4 : Begin
                     delete(upcase_zeile,1,3);
                     while (upcase_Zeile[1] = ' ') and
                           (length(upcase_Zeile)>0) do  delete(upcase_Zeile,1,1);
                     upcase_zeile:=cutstr(upcase_zeile);
                     catalog(upcase_zeile);
                   End;

               5 : Begin
                      makedn(upcase_Zeile,dateiname);
                      lesefile(dateiname);
                   End;

               6 : begin
                     wrtastpuf(#0+#118+#0+#81+#0+#118+#0+#81);
                     lesefile(syspfad+'PACK.LOG');
                   end;

               7 : Begin
                     if NR_remote then
                     Begin
                       NR_Par := '';
                       NR_Wert := '';
                       delete(upcase_zeile,1,pos(' ',upcase_zeile));
                       while (upcase_Zeile[1] = ' ')
                         and (length(upcase_Zeile) > 0) do
                         delete(upcase_Zeile,1,1);
                       while ((upcase_Zeile[1] >= '0') and (upcase_zeile[1] <= '9'))
                         and (length(upcase_Zeile) > 0 ) do
                         Begin
                           NR_Par := NR_Par + upcase_Zeile[1];
                           delete(upcase_Zeile,1,1);
                         End;
                       while (upcase_Zeile[1] = ' ')
                         and (length(upcase_Zeile) > 0) do
                         delete(upcase_Zeile,1,1);
                       while ((upcase_Zeile[1] >= '0') and (upcase_zeile[1] <= '9'))
                         and (length(upcase_Zeile) > 0 ) do
                         Begin
                           NR_Wert := NR_Wert + upcase_Zeile[1];
                           delete(upcase_Zeile,1,1);
                         End;
                       val(NR_Par,i1,i);
                       if i <> 0 then i1 := 0;
                       InputZeile := 'p ';
                       for i := 2 to i1 do InputZeile := InputZeile + '* ';
                       InputZeile := InputZeile + NR_Wert;
                       V_aus(show,InputZeile);
                       cursor(show);
                       cmd:=false;
                       ch_out:=' ';
                       exit;
                     End;
                   End;

               8 : Begin
                     if show = 0 then poll_Moni := unproto;
                     S_Com(show,'H');
                     if (show = 0) AND
                        (pos('heard 0',Response) = 0) AND
                        (pos('- heard',Response) <> 0) THEN
                     Begin
                       (* auf Kanal 0 die Heard-Liste auslesen *)
                       Moni_off;
                       TextAttr := MoniInfoAttrib;
                       M_aus(' '^M);
                       M_aus('Rufzeichen   zuerst gehoert     zuletzt gehoert');
                       M_aus('  I-Frames     RR    REJ    RNR' + ^M);
                       M_aus(conststr('-',80)+ ^M);
                       repeat
                         SendTNC(0,1,'G');
                         readaux(ch);  (* KanalNummer *)
                         readaux(ch);  (* Code *)
                         i2 := ord(ch);
                         i := 0;
                         repeat
                           readaux(ch); inc(i); upcase_Zeile[i] := ch;
                         until ch = #0;
                         upcase_Zeile[0] := chr(i);       (* Der String      *)
                         upcase_Zeile[i] := #13;          (* upcase_Zeile    *)
                         M_aus(upcase_Zeile);             (* wird nur als    *)
                         Uhr_aus;                         (* Hilfsstring ben.*)
                       until (i2 <> 5) or keypressed;
                       if keypressed then
                       Begin
                         ch := readkey;
                         if ch = #0 then ch := readkey;
                         S_Text(0,#13);  (* Ausgabe stoppen *)
                       End;
                       M_aus(' '^M);
                       restore_MoniStatus;
                     End;
                   End;

               9 : Begin
                     (* Headerstatus anzeigen/verndern *)
                     i := pos(' ',upcase_Zeile);
                     if i = 0 then
                     Begin
                       (* Kein neuer Wert angegeben *)
                       M_aus(Channel_ID(show)+'HEADER ');
                       if Header then M_aus('1' + ^M) else M_aus('0' + ^M);
                     End
                     else
                     Begin
                       (* neuer Wert *)
                       val(copy(upcase_Zeile,i+1,length(upcase_Zeile)-i),i1,Err_Result);
                       if (Err_Result = 0) THEN Header := (i1 = 1);
                     End;
                   End;

               10: BEGIN                   (* SUB-Befehl (von DC6LK) *)
                     Fenster (2,2,50,10,'Path - Name');
                     gotoxy(4,5); write('Aktueller Path :');
                     AMerk := TextAttr;  TextAttr := neg_fett;
                     gotoxy(4,6); write(Drive);
                     TextAttr := AMerk;
                     gotoxy(4,7);
                     write('<TAB> <CR> Wert aus Config wieder bernehmen');
                     gotoxy(4,8); write('<ESC> fr Abbruch');
                     gotoxy(3,10); write('Path: ');
                     GetString (Drive,40,9,10,ch);
                     if Drive = '' then Drive := Merk_Drive;
                     if pos(':',drive)=0 then
                      begin getdir(0,zeile); drive:=copy(zeile,1,2)+drive; end;
                     if (Drive[length(Drive)]<>'\') AND (length(Drive)<>0) then
                            Drive := Drive + '\';
                     if length (Drive) > 13 THEN  Pfad_Ueber := Length (Drive) - 13
                                            else  Pfad_Ueber := 0;
                     Neu_Bild;
                   END;

               11: BEGIN
                     (* Bei DER BOX privilegiert einloggen (ab DIE BOX V1.4) *)
                     IF MB_remote AND MBX_Rufzeichen(show) AND connected THEN
                     BEGIN
                       _aus(show,'PRIV ' + PassWort + ^M);
                       S_Text(show,'PRIV ' + PassWort + ^M);
                     END
                     ELSE Beep(220,200);
                   END;

               12: begin  (* ? - Kommando *)
                     if pos('TNC',upcase_zeile)=0 then dateiname:='PRHELP.TXT'
                                                  else dateiname:='TNCHELP.TXT';
                     
                     lesefile(syspfad+dateiname);
                   end;
               13:; (* QRES- Kommando, hier einfach nix machen *)

               14:  (* DEL - Kommando *)  del_File(upcase_Zeile);

               15: Begin (* CALL - Kommando *)
                     delete(upcase_Zeile,1,5);
                     while (upcase_Zeile[1] = ' ')
                         and (length(upcase_Zeile) > 0) do
                         delete(upcase_Zeile,1,1);
                     Call := CutStr(upcase_Zeile);
                     StatusOut(show,4,dunkel,'         ');
                     StatusOut(show,4,hell,Call);
                     connected:=true; neu_bild;
                   End;
               16: begin
                     Moni_off; (* @ diese und untere Zeile weglassen, *)
                     getdir(0,zeile); cursor_ein; clrscr; gotoxy(1,4);
                     highvideo;
                     writeln('Zurck zu TP mit Exit<CR> !'+#13);
                     lowvideo;
                     swapvectors; exec(shell,'/e'); swapvectors;
                     i:=doserror;
                     neu_bild; cursor_aus; chdir(zeile);
                     restore_MoniStatus; (* @ wenn Monitor in DOS weitergehen soll *)
                     if i > 0 then begin
                       textattr:=neg_blink;
                       M_aus('DOS-ERROR Nr.'+int_str(i)+
                             ' beim Versuch '+shell+' zu laden.'+^M);
                       if Klingel then write(^G); end;
                   end;
               17: begin   (* anderes SSID ans Host-Call auf diesem Kanal *)
                     zeile:=copy(inputzeile,4,2);
                     val(zeile,i1,i);
                     if (i=0) and (i1 >=0) and (i1<=15) then
                     begin                    (* hostcall hat keinen SSID *)
                       zeile:='I '+hostcall+'-'+zeile;
                       s_com(show,zeile);
                       s_com(show,'I');
                     end;
                   end;
               18: begin
                     if show=0 then i:=unproto else i:=k[show]^.RS232;
                     if (length(inputzeile)>3) then  (* nicht nur "* id" *)
                     begin
                       if (length(inputzeile)<12) and (inputzeile[4]<>' ') then  (* richtiges format *)
                       begin
                         if show=0 then
                         begin
                           schnitte[i].ident:=copy(inputzeile,4,
                                                    length(inputzeile)-3);
                           poll_moni:=unproto;
                           StatusOut(0,2,1,copy(Channel_ID(0)+
                                           copy(space,1,7),1,8));
                         end
                         else begin
                           textattr:=norm;
                           if klingel then beep(220,50);
                           m_aus('ID nur am Monitor aendern !'+^M);
                         end; (* if show=0 ..else *)
                       end (* if length(inputz)<14..*)
                       else begin
                         textattr:=norm;
                         m_aus(inf+schnitte[i].ident+' ist TNC Nr.'+int_str(i)+^M);
                       end;
                     end (* if length(inpz)>4..*)
                     else begin                            (* nur "* id" *)
                       textattr:=norm;
                       m_aus(inf+schnitte[i].ident+' ist TNC Nr.'+int_str(i)+^M);
                     end;
                   end; { 18: }
               19: begin
                   {$IFDEF SYSOP}
                     i := pos(' ',upcase_Zeile);
                     if (i > 0) and (show > 0) then
                     Begin
                       (* Wert *)
                       val(copy(upcase_Zeile,i+1,length(upcase_Zeile)-i),i1,Err_Result);
                       if (Err_Result = 0) and (i1 > 0) and (i1 <= 255) then
                         begin anz_auswert:=i1; nr_auswert:=1+random(anz_auswert);
                               _aus(show,'Autom. SYSOP-Sendung THENET (" SYS ")'+
                                         '   Anzahl: '+int_str(anz_auswert)+
                                         '   Richtiges Wort Nr.: '+int_str(nr_auswert)+ ^M);
                               s_text(show,'SYS'+#13);
                         end
                       else
                       Begin
                         if Klingel then beep(220,20);
                         M_aus('Fehler bei SYSOP - Eingabe!' + ^M);
                       End;
                     End;
                   {$ENDIF}
                   End; {19}

              20:  if auto and sek30 then remote(show,upcase_zeile)
                      else _aus(show,inf+'Fernsteuerung abgeschaltet'+^M);

              ELSE if ( (length(inputzeile)>2) and (inputzeile[2]=' ') ) or
                      ( length(inputzeile)=1)  then
                   begin
                     if show = 0 then poll_Moni := unproto;
                     S_Com(show,InputZeile)
                   end
                   else
                   begin
                     if Klingel then beep(220,50);
                     m_aus('Fehler bei Kommandoeingabe ( 2.Zeichen = <SPACE> ?)'+^M);
                   end;

              END; (* CASE *)

              Cursor(show);
              InputZeile := '';
              cmd := false
            End;

       ^I,#27
          : Begin
              cmd := false;
              InputZeile := '';
              X1 := 1;
              _clreol(show);
              Cursor(show)
            End;
       ^H : Begin
              if length(InputZeile) > 0 then
              Begin
                delete(InputZeile,length(InputZeile),1);
                V_aus(show,^H^H'  '^H^H);
                Cursor(show)
              End
              else
              Begin
                cmd := false;
                X1 := 1;
                _clreol(show);
                Cursor(show)
              End;
            End;
      ^J  : Begin
              InputZeile := InputZeile + #13;
              V_aus(show,^H' '^M);
              Cursor(show);
            End;
       #32..#126 :
            Begin
              if length(InputZeile) = 0 then
              Begin
                X1 := 4;
                _clreol(show);
              End;
              InputZeile := InputZeile + ch_out;
              TextAttr := norm;
              V_aus(show,^H+ch_out);
              Cursor(show);
            End;
      #201..#210   (* Bildschirmseiten umschalten *)
          : Begin
              i := ord(ch_out) - 200;
              if i = 10 then i := 0;
              if (K[i]^.poll) and (i <= maxlink) then
              Begin
                show := i;
                K[i]^.NochNichtGelesen := false;
                Neu_Bild;
              End;
            End;
      #224: begin
             inputzeile:=inputzeile+last_cmd;
             textattr:=norm;
             v_aus(show,^H+inputzeile); cursor(show);
             textattr:=textattrmerk;
            end;
       else Begin
              if Klingel then write(^G);
            End;
      End;  (* case ch_out of ... *)
    End      (* of Kommando *)
    else
    Begin   (* richtiger Tastatur-Dekoder, kein Kommando-Modus *)
      case ch_out of
       ^A  : Begin
               if show <> 0 then
               Begin
                 Auto := not Auto;
                 if Auto then StatusOut(show,66,hell,'A')
                         else StatusOut(show,66,dunkel,' ');
               End;
             End;
       ^B  : Begin
              ScreenSTBY := true; clrscr;
              gotoxy(1,25);
             End; (* screentimer *)
       ^C  : ;
       ^P  : Begin     (* Drucker toggle *)
             (* durch ^P wird ^D frei fr unix wie z.B. an DB0ID *)
               if Drucker then
               Begin   (* Drucker ausschalten *)
                 Drucker := false;
                 for i := 0 to maxLink do StatusOut(i,28,dunkel,'      ');
               End
               else
               Begin
                 IF LPT1_vorhanden THEN BEGIN
                   D_ON := false;
                   for i := 0 to maxLink do
                   Begin
                     if K[i]^.Drucker then D_On := true;
                   End;
                   if D_ON then                        (* Drucker schon ein *)
                     begin if Klingel then write(^G); end
                   else
                   Begin
                     IF NOT LPT1_Error THEN BEGIN
                       Drucker := true;
                       for i := 0 to maxLink do
                              StatusOut(i,28,hell,'Druck'+char(48+show));
                     END
                     ELSE BEGIN     (* Irgendwas ist am Drucker faul ... *)
                       Fenster(25,7,20,5,'Printer - Fehler');
                       write(^G);
                       delay(1000);
                       Neu_Bild;
                     END;
                   End;
                 END;
               End;
             End;
       ^E  : Begin           (* ctrl-E = File-EMPFANGS-Menue *)
               Save := not Save;
               if Save then
               Begin
                 fileEmpfNochmal:
                 V_aus(show,^H' '^H);
                 Fenster(2,2,35+Pfad_Ueber,10,'File EMPFANGEN');
                 FileMenue;
                 if ch <> #27 then
                 Begin
                   case ch of
                    'T' : RX_bin := 0;
                    'B' : RX_bin := 1;
                    'A' : RX_bin := 2; (* Vorstadium fr Auto-Send *)
                   end;
                   gotoxy(4,10);  write(copy(space,1,31));
                   gotoxy(4,10);  write('Name: ');
                   GetString(Save_Name,25+Pfad_Ueber,10,10,ch);
                   if ch <> #27 then
                   Begin
                     if Save_Name = '' then
                               Save_Name := Drive+'F'+chr(show+48)+'.TXT';
                     makedn(save_name,save_name);
                     gotoxy(10,10);
                     write(Save_Name);
                     assign(RXFile,Save_Name);
                     setTextBuf(RXFile,RXFileBuffer);
                     if RX_bin = 0 then  (* Textfile *)
                     begin
                       openSaveFile(show);
                       if not save then
                       begin
                        file_error(save_name);
                        save:=true;
                        goto FileEmpfNochmal;
                       end;
                     end
                     else
                       Begin (* Binrfile *)
                         RX_Count := 0;
                         (*$I-*) reset(RXFile); (*$I+*)
                         if IOResult = 0 then
                         Begin  (* File vorhanden !!! *)
                           close(RXFile);
                           clr_FileMenue;
                           gotoxy(4,6);  write('File ''',Save_Name,'''');
                           gotoxy(4,7);  write('ist vorhanden !!');
                           gotoxy(4,10); write(^G'File berschreiben?  J/N ');
                           repeat
                             ch := upcase(ReadKey);
                           until (ch = 'J') or (ch = 'N');
                           if ch = 'J' then rewrite(RXFile)
                                       else save := false;
                         End
                         else
                         Begin (* alles klar, File ist nicht da *)
                           (*$I-*) rewrite(RXFile); (*$I+*)
                           if ioresult <> 0 then
                           begin
                             save:=false;
                             file_error(save_name);
                             goto FileEmpfnochmal;
                           end;
                         End;
                       End; (* binr *)
                   End
                   else save := false;
                   if save then StatusOut(show,15,hell,saven(show));
                 End
                 else Save := false;

                 Cursor_aus;
                 Neu_Bild;
                 Cursor(show);

               End
               else
               Begin
                 StatusOut(show,15,dunkel,copy(space,1,12));
                 close(RXFile);
               End;
             End;
       ^F  : BEGIN { Ctrl-F = Ctrl-E mit Textfile f?.txt }
               Save := not Save;
               if Save then
               Begin
                  RX_bin := 0;
                  Save_Name := Drive+'F'+chr(show+48)+'.TXT';
                  assign(RXFile,Save_Name);
                  setTextBuf(RXFile,RXFileBuffer);
                  openSaveFile(show);
                  StatusOut(show,15,hell,saven(show));
               End
               else
               Begin
                  StatusOut(show,15,dunkel,copy(space,1,12));
                  close(RXFile);
               End;
             End;

       ^H  : Begin
               if (length(InputZeile) > 0) then
               Begin
                 delete(InputZeile,length(InputZeile),1);
                 if X1 > 2 then  V_aus(show,^H^H'  '^H^H)
                           else
                                 Begin
                                   V_aus(show,^M^M);
                                   V_aus(show,InputZeile);
                                 End;
                 Cursor(show);
               End
               else if Klingel then beep(880,50);
             End;
       ^I,#27
           : Begin
               if (length(InputZeile) = 0) then
               Begin
                 cmd := true;
                 X1 := 1;
                 TextAttr := norm;
                 V_aus(show,'* ');
                 Cursor(show);
               End
               else if Klingel then beep(440,50);
             End;
       ^J  : Begin
               InputZeile := InputZeile + #13;
               V_aus(show,^H' '^M);
               Cursor(show);
             End;
       #251: Begin (* ALT-J *)
               ch_out := ^J;
               chr_darstell;
             End;
       ^K  : Begin
               if show = 0 then
               Begin
                 Klingel := not Klingel;
                 if Klingel then StatusOut(0,70,hell,'K')
                            else StatusOut(0,70,dunkel,' ');
               End;
             End;
       ^L  : ;
       ^N  : if connected then callinf(show,call,true)
                          else lesefile(syspfad+'CALL.PR');
       ^M  : if not filesend then
              Begin
                V_aus(show,^H' '^M);
                Cursor(show);
                InputZeile := InputZeile + #13;
                TX_out;
              End;
       ^O,^P,^Q,^R : ;
       ^S  : Begin                (* ctrl-S = File-SENDE-Menue *)
               if show <> 0 then
               Begin
                 if FileSend then
                 Begin
                   FileSend := false;
                   S_Text(show,^M^M);
                   _aus(show,^M^M);
                   close(TXFile);
                   StatusOut(show,58,dunkel,'      ');
                 End
                 else
                 Begin
                   V_aus(show,^H' '^H);
                   FileSendNochmal:
                   Fenster(2,2,35+Pfad_Ueber,10,'File SENDEN');
                   FileMenue;
                   if ch <> #27 then
                   Begin
                     case ch of
                      'T' : TX_bin := 0;
                      'B' : TX_bin := 1;
                      'A' : TX_bin := 2;
                     end;
                     gotoxy(4,10);   write(copy(space,1,31));
                     gotoxy(4,10);   write('Name: ');
                     FileName := '';
                     GetString(Filename,25+Pfad_Ueber,10,10,ch);
                     if ch <> #27 then
                     Begin
                       makedn(filename,filename);
                       gotoxy(10,10);  write(Filename);
                       assign(TXFile,Filename);
                       (*$I-*)  reset(TXFile,1);  (*$I+*)
                       if IOResult = 0 then
                       Begin
                         (* File vorhanden *)
                         TX_Laenge := FileSize(TXFile);
                         close(TXFile);
                         reset(TXFile);
                         blockread(TXFile,TX_Buffer,8,i);
                         TX_Count := 0;
                         TX_Buffer_Count := 0;
                         FileSend := true;
                         StatusOut(show,58,hell,'FileTX');
                         FileSend := true;
                         if TX_bin = 2 then
                         Begin
                           (* Bei Auto-Bin-Send die Filelnge bertragen *)
                           str(TX_Laenge,InputZeile);
                           InputZeile := '#BIN#' + InputZeile + ^M;
                           TX_Out;
                         End;
                       End
                       else
                       Begin                     (* File nicht vorhanden *)
                         file_error(filename);
                         goto FileSendNochmal;
                       End;
                     End
                     else goto FileSendNochmal;
                   End;

                   Cursor_aus;
                   Neu_Bild;
                   Cursor(show);

                 End;
               End;
             End;
       ^T  : Begin
               if show = 0 then
               Begin
                 Time_stamp := not Time_stamp;
                 if Time_stamp then StatusOut(0,66,hell,'T')
                               else StatusOut(0,66,dunkel,' ');
               End;
             End;
       ^U  : Begin
               Umlaut := not Umlaut;
               if Umlaut then StatusOut(show,68,hell,'U')
                         else StatusOut(show,68,dunkel,' ');
             End;
       ^V  : ;
       ^W  : ;
       ^X  : ;
       ^Y  : begin
              V_aus(show,^M^M);
              cursor(show);
              InputZeile := '';
             end;

       #252: begin (*ALT-D *)
               fenster(6,6,23,8,'Gesamt-Disconnect');
               gotoxy(8,9);  write('Ein Discconnect auf');
               gotoxy(8,10); write('Kanlen erwnscht?');
               gotoxy(9,12); write('Drcke <J> / <N>');
               repeat
                 wd:=taste;
                 if (wd>=106) and (wd<=110) then wd:=wd-32;
               until (wd=74) or (wd=78);
               neu_bild;
               if wd=74 then
               begin
                 for i:=1 to maxlink do if K[i]^.poll then s_com(i,'d');
               end;
             end;

       #250: qrt:=true; (* Programm-Ende mit <ALT>-X *)

       #28..#31 : ;

       #201..#210   (* Bildschirmseiten umschalten *)
           : Begin
               i := ord(ch_out) - 200;
               if i = 10 then i := 0;
               if (K[i]^.poll) and (i <= maxlink) then
               Begin
                 show := i;
                 K[i]^.NochNichtGelesen := false;
                 Neu_Bild;
               End;
             End;
       #221: Begin                 (* TrennZeile nach unten *)
               if (Trenn < 25) and (show <> 0) then
               Begin
                 inc(Trenn);
                 if Trenn > 23 then Trenn := 25;
                 Neu_Bild;
                 for i := 1 to maxLink do K[i]^.Trenn := Trenn;
               End;
             End;
       #230: Begin                 (* TrennZeile nach oben *)
               if (Trenn > 6) and (show <> 0) then
               Begin
                 dec(Trenn);
                 if Trenn > 23 then Trenn := 23;
                 Neu_Bild;
                 for i := 1 to maxLink do K[i]^.Trenn := Trenn;
               End;
             End;
       #224: begin (* HOME_TASTE *)
               inputzeile:=inputzeile+copy(merkinput,1,length(merkinput)-1);
               v_aus(show,^H+copy(merkinput,1,length(merkinput)-1));
               cursor(show);
             end;
       #211..#220
           : Begin
               (* Kommando-Folge auslsen *)
               IF (LinkState = 0) AND (show <> 0)THEN BEGIN
                 inputzeile:=''; v_aus(show,^M+^M);
                 cmd_Nummer := ord(ch_out) - 210;
                 Auto_cmd_darstellen;
                 IF Auto_cmd THEN BEGIN
                   X1 := 1;
                   TextAttr := norm;
                   V_aus(show,'* ');
                   V_aus(show,Auto_Command(show,cmd_Nummer,1) + ^M);
                   S_Com(show,Auto_Command(show,cmd_Nummer,1));
                   cmd_Stufe := 2;
                   outside:=false;
                 END;
                 cursor(show);
               End
               else if Klingel then write(^G);
             End;

       #226: umschichten;          (* scrollroutine aufrufen *)

       #228,#229
           : Begin
               if multiTNC then
               Begin
                 repeat
                   inc(unproto);
                   if unproto > maxtnc then unproto := 1;
                 until Schnitte[unproto].TNC;
                 poll_moni:=unproto;
                 StatusOut(0,2,1,copy(Channel_ID(0)+copy(space,1,8),1,8));
               End;
             End;
       #$A0: Begin
               ch_out := '''';
               chr_darstell;
               ch_out := 'a';
               chr_darstell;
             End;
       #$82: Begin
               ch_out := '''';
               chr_darstell;
               ch_out := 'e';
               chr_darstell;
             End;
       #$A1: Begin
               ch_out := '''';
               chr_darstell;
               ch_out := 'i';
               chr_darstell;
             End;
       #$A2: Begin
               ch_out := '''';
               chr_darstell;
               ch_out := 'o';
               chr_darstell;
             End;
       #$A3: Begin
               ch_out := '''';
               chr_darstell;
               ch_out := 'u';
               chr_darstell;
             End;
       '' : Begin
               if Umlaut then  ch_out := '{'
               else
                 Begin ch_out := 'a'; chr_darstell; ch_out := 'e'; End;
               chr_darstell;
             End;
       '' : Begin
               if Umlaut then ch_out := '|'
               else
                 Begin ch_out := 'o'; chr_darstell; ch_out := 'e'; End;
               chr_darstell;
             End;
       '' : Begin
               if Umlaut then ch_out := '}'
               else
                 Begin ch_out := 'u'; chr_darstell; ch_out := 'e'; End;
               chr_darstell;
             End;
       '' : Begin
               if Umlaut then ch_out := '['
               else
                 Begin ch_out := 'A'; chr_darstell; ch_out := 'e'; End;
               chr_darstell;
             End;
       '' : Begin
               if Umlaut then ch_out := '\'
               else
                 Begin ch_out := 'O'; chr_darstell; ch_out := 'e'; end;
               chr_darstell;
             End;
       '' : Begin
               if Umlaut then ch_out := ']'
               else
                 Begin ch_out := 'U'; chr_darstell; ch_out := 'e'; end;
               chr_darstell;
             End;
       '' : Begin
               if Umlaut then ch_out := '~'
               else
                 Begin ch_out := 's'; chr_darstell; ch_out := 's'; end;
               chr_darstell;
             End;
       #201..#255: ;

       else  chr_darstell;
      End;  (* of case *)

      if length(InputZeile) >= 254 then TX_out;

    End;  (* not Kommando *)
    TextAttr := AMerk;

  End;  (* of 'with ...' *)

End;

(* Festspeichertext untersuchen und ausgeben *)

 procedure msgout (msgNummer : integer);
 const ZeitString  = '##ZEIT##';
       DatumString = '###DATUM###';
 var msgZeiger   : integer;
     msgZeile    : str255;
     AMerk       : byte;
     ZeitMerk    : boolean;
     DatumMerk   : boolean;
     i,x,y,z     : integer;
     B_str       : string[11];
     B_Zeiger    : integer;
 Begin
   AMerk := TextAttr;
   TextAttr := conTXAttrib;
   if show = 0 then poll_Moni := unproto;
   repeat
     msgZeile := '';
     ZeitMerk := false;
     DatumMerk := false;
     B_Zeiger := 1;
     for msgZeiger := 1 to 255 do
     Begin
       if (msg[msgNummer,msgZeiger]='#') and not ZeitMerk and not DatumMerk then
       Begin            (* vielleicht soll Datum oder Zeit ausgegeben werden *)
         ZeitMerk := true; DatumMerk := true;
         B_Zeiger := 1;
         for i := 0 to 7 do
           if upcase(msg[msgNummer,msgZeiger + i]) <> copy(ZeitString,i+1,1)
              then ZeitMerk := false;
         for i := 0 to 10 do
           if upcase(msg[msgNummer,msgZeiger + i]) <> copy(DatumString,i+1,1)
              then DatumMerk := false;
         if ZeitMerk then B_str := Time;
         if DatumMerk then B_str := Date;
       End; (*if (msg[msgnummer.. *)
       if msg[msgNummer,msgZeiger] <> #0 then
       Begin
         if ZeitMerk or DatumMerk then
         Begin
           msgZeile := msgZeile + B_Str[B_Zeiger];
           inc(B_Zeiger);
           if ZeitMerk then
           Begin
             if B_Zeiger >= 9 then ZeitMerk := false;
           End
           else
           Begin
             if B_Zeiger >= 12 then DatumMerk := false;
           End;
         End
         else
         Begin
           case msg[msgNummer,msgZeiger] OF
            '' : msgZeile := msgZeile + '[';
            '' : msgZeile := msgZeile + '\';
            '' : msgZeile := msgZeile + ']';
            '' : msgZeile := msgZeile + '{';
            '' : msgZeile := msgZeile + '|';
            '' : msgZeile := msgZeile + '}';
            '' : msgZeile := msgZeile + '~';
           else msgZeile := msgZeile + msg[msgNummer,msgZeiger];
           end;
         End; (* if zeitmerk or datummerk... *)
       End; (* if msgnummer <> .. *)
     End; (* for msgzeiger .. *)
     x:=0; y:=0; z:=0;
     for i:=1 to length(msgzeile) do          (* berechnung der max anzahl  *)
     begin                                    (* von zeilen und zeilenlnge *)
       inc(y);                                (* x: Anzahl der zeilen       *)
       if msgzeile[i]=#13 then                (* y: Zwischenz. Zeilenlnge  *)
       begin                                  (* z: Lnge der grten Zeile *)
        inc(x); if z < y then z:=y; y:=0;
       end;
     end;
     if z < y then z:=y;                      (* letzte Zeile noch lnger ? *)
     inc(z,3); inc(x,6);                      (* 3 spaces und 6 zeilen mehr *)
     if z > 80 then z:=80;                    (* maximal Lnge *)
     if z < 22 then z:=22;                    (* mindestlnge *)
     Fenster(1,6,z,x,'Festspeicher-Text'+int_str(msgnummer));
      x:=3; y:=9;                             (* nun sind x,y koordinaten! *)
      gotoxy(x,y);                            (* anzeige des Textes *)
      for i:=1 to length(msgzeile) do
      begin
       if msgzeile[i] <> #13 then             (* wenns kein <CR> ist.. *)
       begin
         if msgzeile[i] = #7 then                (* ein GONG drin *)
         begin
           TextAttr := ctrlAttrib; write('G'); TextAttr := conTXAttrib;
         end
         else WRITE(msgzeile[i]);
       end
       else begin inc(y); gotoxy(x,y); end;  (* wenn <CR> nchste zeile *)
      end;
      inc(y); GotoXY(x,y); WRITE('<ESC> / <ENTER>');
      wd:=taste;
      if (wd>=340) and (wd<=349) then msgnummer:=wd-339;
      neu_bild;
   until (wd=13) or (wd=27);
   IF (wd = 27) THEN msgzeile:='';
   for i:=1 to length(msgzeile)-1 do
     begin
      if msgzeile[i]=#13 then ch_out:=#10 else ch_out:=msgzeile[i];
      auswerttaste;
     end;
   if length(msgzeile)>0 then ch_out:=' '; auswerttaste;
   msgzeile:='';
   TextAttr := AMerk;
 End;    (* msg_out *)


(* Tast_Decode codiert die Sondertasten um *)

FUNCTION Tast_Decode : CHAR  ;
var ch : char;
BEGIN
  ch := ReadKey;
  case ch of

   #59 : Tast_decode := #201;  (* F1 *)
   #60 : Tast_decode := #202;
   #61 : Tast_decode := #203;
   #62 : Tast_decode := #204;
   #63 : Tast_decode := #205;
   #64 : Tast_decode := #206;
   #65 : Tast_decode := #207;
   #66 : Tast_decode := #208;
   #67 : Tast_decode := #209;
   #68 : Tast_decode := #210;  (* F10 *)

   #104: Tast_decode := #211;  (* ALT + F1 *)
   #105: Tast_decode := #212;
   #106: Tast_decode := #213;
   #107: Tast_decode := #214;
   #108: Tast_decode := #215;
   #109: Tast_decode := #216;
   #110: Tast_decode := #217;
   #111: Tast_decode := #218;
   #112: Tast_decode := #219;
   #113: Tast_decode := #220;  (* ALT + F10 *)

   #84 : Tast_decode := #231;  (* shift + F1 *)
   #85 : Tast_decode := #232;
   #86 : Tast_decode := #233;
   #87 : Tast_decode := #234;
   #88 : Tast_decode := #235;
   #89 : Tast_decode := #236;
   #90 : Tast_decode := #237;
   #91 : Tast_decode := #238;
   #92 : Tast_decode := #239;
   #93 : Tast_decode := #240;  (* shift + F10 *)

   #72 : Tast_decode := #230;  (* Cursor up *)
   #80 : Tast_decode := #221;  (* Cursor down *)
   #75 : Tast_decode := #222;  (* Cursor left *)
   #77 : Tast_decode := #223;  (* Cursor right *)
   #71 : Tast_decode := #224;  (* Home *)
   #79 : Tast_decode := #241;  (* END *)
   #73 : Tast_decode := #226;  (* PgUp *)
   #81 : Tast_decode := #227;  (* PgDn *)
   #82 : Tast_decode := #228;  (* Ins *)
   #83 : Tast_decode := #229;  (* Del *)

   #45 : Tast_decode := #250;  (* ALT-X *)
   #32 : tast_decode := #252;  (* ALT-D *)
   #36 : Tast_decode := #251;  (* ALT-J *)

   else  Tast_decode := #255;  (* alle anderen Sequenzen sperren *)
  END;

END;  (* Tast_Decode *)


(*
   Tastatur solange abfragen, bis kein Zeichen mehr kommt
*)

procedure poll_Tastatur;
Begin
  while keypressed do
  Begin
    ch_out := ReadKey;
    if ch_out = #0 then ch_out := Tast_Decode;
    if (ch_out >= #231) and (ch_out <= #240) then msgout(ord(ch_out)-230)
                                             else AuswertTaste;
  End;
End;
